function data = openCone(data, zerotol)
% remove the prior closure of the cone
%
% THIS FUNCTION IS NO USER FUNCTION.

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2013 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

if isstruct(data) && isfield(data, 'A')
    %% hrep
    removeFilter = data.h == max(data.h);
    data.A(removeFilter, :) = [];
    data.h(removeFilter) = [];
elseif isstruct(data) && isfield(data, 'V')
    %% vrep
    distanceVector = sum(data.V.^2, 2);
    removeFilter = distanceVector < zerotol*max(distanceVector);
    data.V(removeFilter, :) = [];
elseif isnumeric(data)
    %% rayMatrix (vrep without structure)
    distanceVector = sum(data.^2, 2);
    removeFilter = distanceVector < zerotol*max(distanceVector);
    data(removeFilter, :) = [];
else
    error('elk:decompoisition:internalError', 'This should not happen');
end
        